"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRemote = void 0;
var tslib_1 = require("tslib");
var vue_1 = require("vue");
var vue_router_1 = require("vue-router");
var core_1 = require("@leanjs/core");
var configureMount = core_1._.configureMount, getDefaultPathname = core_1._.getDefaultPathname, dedupeSlash = core_1._.dedupeSlash;
var createRemote = function (App, config) {
    return function (options) {
        var isSelfHosted = options.isSelfHosted;
        var _a = config || {}, createRuntime = _a.createRuntime, onBeforeMount = _a.onBeforeMount, _b = _a.router, _c = _b === void 0 ? {} : _b, _d = _c.routes, routes = _d === void 0 ? [] : _d, routerConfig = tslib_1.__rest(_c, ["routes"]);
        var mount = function (el, _a) {
            var _b = _a === void 0 ? {} : _a, _c = _b.runtime, runtime = _c === void 0 ? createRuntime === null || createRuntime === void 0 ? void 0 : createRuntime() : _c, onRemoteNavigate = _b.onRemoteNavigate, basename = _b.basename, _d = _b.pathname, pathname = _d === void 0 ? getDefaultPathname(isSelfHosted) : _d;
            var app;
            var semaphore = true;
            var history = isSelfHosted
                ? (0, vue_router_1.createWebHistory)(basename)
                : (0, vue_router_1.createMemoryHistory)(basename);
            history.replace(pathname);
            var router = (0, vue_router_1.createRouter)(tslib_1.__assign({ history: history, routes: routes }, routerConfig));
            return tslib_1.__assign(tslib_1.__assign({}, configureMount(tslib_1.__assign(tslib_1.__assign({ el: el }, options), { log: createRuntime === null || createRuntime === void 0 ? void 0 : createRuntime.log, runtime: runtime, onBeforeMount: onBeforeMount, cleanups: onRemoteNavigate
                    ? [
                        router.beforeEach(function (to, from) {
                            if (from !== vue_router_1.START_LOCATION) {
                                onRemoteNavigate === null || onRemoteNavigate === void 0 ? void 0 : onRemoteNavigate({
                                    pathname: [basename, to.path]
                                        .join("/")
                                        .replace(/\/{2,}/g, "/"),
                                    hash: to.hash,
                                    // TODO search: to.query,
                                });
                            }
                        }),
                    ]
                    : [], render: function (_a) {
                    var appProps = _a.appProps;
                    app = (0, vue_1.createApp)(App, tslib_1.__assign(tslib_1.__assign({}, appProps), { isSelfHosted: isSelfHosted }))
                        .provide("runtime", runtime)
                        .use(router);
                    app.mount(el);
                }, unmount: function () {
                    app === null || app === void 0 ? void 0 : app.unmount();
                } }))), { onHostNavigate: function (_a) {
                    var rawNextPathname = _a.pathname;
                    return tslib_1.__awaiter(void 0, void 0, void 0, function () {
                        var nextPathname;
                        return tslib_1.__generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    nextPathname = basename
                                        ? dedupeSlash(rawNextPathname.replace(basename, "/"))
                                        : rawNextPathname;
                                    if (!(semaphore && nextPathname !== history.location)) return [3 /*break*/, 2];
                                    semaphore = false;
                                    // We need a semaphore here because VueRouter router.push is async.
                                    // router.push triggers an event in the router of the host because of onRemoteNavigate,
                                    // which triggers onHostNavigate again. However, history.location is not yet updated this second time because router.push is async.
                                    // That creates an infinite loop. This semaphore avoids such infinite loop.
                                    return [4 /*yield*/, (router === null || router === void 0 ? void 0 : router.push(nextPathname))];
                                case 1:
                                    // We need a semaphore here because VueRouter router.push is async.
                                    // router.push triggers an event in the router of the host because of onRemoteNavigate,
                                    // which triggers onHostNavigate again. However, history.location is not yet updated this second time because router.push is async.
                                    // That creates an infinite loop. This semaphore avoids such infinite loop.
                                    _b.sent();
                                    semaphore = true;
                                    _b.label = 2;
                                case 2: return [2 /*return*/];
                            }
                        });
                    });
                } });
        };
        return { mount: mount, createRuntime: createRuntime };
    };
};
exports.createRemote = createRemote;
